package com.gic.cloud.dao.mapper;

import com.gic.cloud.entity.TabAttentionStore;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabAttentionStoreMapper {
    /**
     * 根据主键删除
     *
     * @param attentionId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer attentionId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabAttentionStore record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabAttentionStore record);

    /**
     * 根据主键查询
     *
     * @param attentionId 主键
     * @return 实体对象
     */
    TabAttentionStore selectByPrimaryKey(Integer attentionId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabAttentionStore record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabAttentionStore record);

    Page<TabAttentionStore> pageStoreAttention(@Param("userId") Integer userId, @Param("enterpriseId") Integer enterpriseId);

    int removeAttention(@Param("userId") Integer userId,
                        @Param("enterpriseId") Integer enterpriseId,
                        @Param("storeIds")List<Integer> storeIds);
}