package com.gic.cloud.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.dto.DataExplainDTO;
import com.gic.cloud.dto.IndexDescDTO;
import com.gic.cloud.service.DataExplainApiService;
import com.gic.cloud.service.IndexDescApiService;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.ResultControllerUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-27 10:40
 */
@RestController
public class IndexDescController {

    @Autowired
    private IndexDescApiService indexDescApiService;
    @Autowired
    private DataExplainApiService dataExplainApiService;

    @RequestMapping("/list-index-desc")
    public RestResponse listIndexDesc(Integer enterpriseId, String moduleId, String indexGroupName) {
        ServiceResponse<List<IndexDescDTO>> serviceResponse = indexDescApiService.listByEnterpriseAndModule(enterpriseId, moduleId, indexGroupName);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-index-desc-detail")
    public RestResponse listByEnterpriseAndModuleDetail(Integer enterpriseId, String moduleId, String indexGroupName, Integer userId) {
        ServiceResponse<List<IndexDescDTO>> serviceResponse = indexDescApiService.listByEnterpriseAndModuleDetail(enterpriseId, moduleId, indexGroupName, userId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-index-desc-recycle")
    public RestResponse listRecycle(Integer enterpriseId, String moduleId, String indexGroupName) {
        ServiceResponse<List<IndexDescDTO>> serviceResponse = indexDescApiService.listRecycle(enterpriseId, moduleId, indexGroupName);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/sort-index-desc")
    public RestResponse sort(Integer enterpriseId, String moduleId, String indexGroupName, Integer indexDescEnterpriseId, Integer seq) {
        ServiceResponse<Void> serviceResponse = indexDescApiService.sort(enterpriseId, moduleId, indexGroupName, indexDescEnterpriseId, seq);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/recycle-index-desc")
    public RestResponse recycle(Integer indexDescEnterpriseId) {
        ServiceResponse<Void> serviceResponse = indexDescApiService.moveToRecycle(indexDescEnterpriseId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }


    @RequestMapping("/get-index-desc")
    public RestResponse getIndexDesc(Integer enterpriseId, String moduleId, String indexGroupName, String indexCode) {
        ServiceResponse<String> serviceResponse = indexDescApiService.getIndexDesc(enterpriseId, moduleId, indexGroupName, indexCode);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/get-data-explain")
    public RestResponse getDataExplain(String moduleId) {
        ServiceResponse<List<DataExplainDTO>> serviceResponse = dataExplainApiService.listByModule(moduleId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

}